diff a/src/hotspot/share/oops/markWord.cpp b/src/hotspot/share/oops/markWord.cpp
--- a/src/hotspot/share/oops/markWord.cpp
+++ b/src/hotspot/share/oops/markWord.cpp
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 1997, 2024, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 1997, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -92,5 +92,19 @@
       st->print("??");
     }
     st->print(" age=%d)", age());
   }
 }
+
+markWord markWord::flat_array_prototype(LayoutKind lk) {
+  switch(lk) {
+    case ATOMIC_FLAT:
+    case NON_ATOMIC_FLAT:
+      return markWord(null_free_flat_array_pattern);
+      break;
+    case NULLABLE_ATOMIC_FLAT:
+      return markWord(nullable_flat_array_pattern);
+      break;
+    default:
+      ShouldNotReachHere();
+  }
+}
